const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const emailAccountService = require('./emailAccount.service');

router.post('/create', authorize(), create);
router.post('/send-email', authorize(), sendEmail);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    emailAccountService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function sendEmail(req, res, next) {
    emailAccountService.sendEmail(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    emailAccountService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    emailAccountService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    emailAccountService.count()
        .then(result => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    emailAccountService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    emailAccountService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    emailAccountService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
